

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.25.22. grn_table &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.25.23. grn_table_cursor" href="grn_table_cursor.html" />
    <link rel="prev" title="7.25.21. grn_search" href="grn_search.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/api/grn_table.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="grn_table_cursor.html" title="7.25.23. grn_table_cursor"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="grn_search.html" title="7.25.21. grn_search"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" accesskey="U"><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.22. </span><code class="docutils literal notranslate"><span class="pre">grn_table</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="grn-table">
<h1><span class="section-number">7.25.22. </span><code class="docutils literal notranslate"><span class="pre">grn_table</span></code><a class="headerlink" href="#grn-table" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.25.22.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p>TODO…</p>
</div>
<div class="section" id="example">
<h2><span class="section-number">7.25.22.2. </span>Example<a class="headerlink" href="#example" title="Permalink to this headline">¶</a></h2>
<p>TODO…</p>
</div>
<div class="section" id="reference">
<h2><span class="section-number">7.25.22.3. </span>Reference<a class="headerlink" href="#reference" title="Permalink to this headline">¶</a></h2>
<dl class="c function">
<dt id="c.grn_table_create">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_table_create</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <em class="property">const</em> char *<em>name</em>, unsigned int <em>name_size</em>, <em class="property">const</em> char *<em>path</em>, grn_obj_flags <em>flags</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>key_type</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>value_type</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_create" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>nameパラメータに対応する新たなtableをctxが使用するdbに定義します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>name</strong> – <p>作成するtableの名前を指定します。NULLなら無名tableとなります。</p>
<p>persistent dbに対して名前をありのtableを作成するときには、flagsに <code class="docutils literal notranslate"><span class="pre">GRN_OBJ_PERSISTENT</span></code> が指定されていなけれなりません。</p>
</p></li>
<li><p><strong>path</strong> – 作成するtableのファイルパスを指定します。
flagsに <code class="docutils literal notranslate"><span class="pre">GRN_OBJ_PERSISTENT</span></code> が指定されている場合のみ有効です。
NULLなら自動的にファイルパスが付与されます。</p></li>
<li><p><strong>flags</strong> – <p><code class="docutils literal notranslate"><span class="pre">GRN_OBJ_PERSISTENT</span></code> を指定すると永続tableとなります。</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_OBJ_TABLE_PAT_KEY</span></code>, <code class="docutils literal notranslate"><span class="pre">GRN_OBJ_TABLE_HASH_KEY</span></code>, <code class="docutils literal notranslate"><span class="pre">GRN_OBJ_TABLE_NO_KEY</span></code> のいずれかを指定します。</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_OBJ_KEY_NORMALIZE</span></code> を指定すると正規化された文字列がkeyとなります。</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_OBJ_KEY_WITH_SIS</span></code> を指定するとkey文字列の全suffixが自動的に登録されます。</p>
</p></li>
<li><p><strong>key_type</strong> – <p>keyの型を指定します。<code class="docutils literal notranslate"><span class="pre">GRN_OBJ_TABLE_NO_KEY</span></code> が指定された場合は無効です。
既存のtypeあるいはtableを指定できます。</p>
<p>key_typeにtable Aを指定してtable Bを作成した場合、Bは必ずAのサブセットとなります。</p>
</p></li>
<li><p><strong>value_type</strong> – keyに対応する値を格納する領域の型を指定します。
tableはcolumnとは別に、keyに対応する値を格納する領域を一つだけ持つことができます。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_add">
grn_id <code class="sig-name descname">grn_table_add</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, <em class="property">const</em> void *<em>key</em>, unsigned int <em>key_size</em>, int *<em>added</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_add" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>keyに対応する新しいrecordをtableに追加し、そのIDを返します。keyに対応するrecordがすでにtableに存在するならば、そのrecordのIDを返します。</p>
<p><code class="docutils literal notranslate"><span class="pre">GRN_OBJ_TABLE_NO_KEY</span></code> が指定されたtableでは、key, key_size は無視されます。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>key</strong> – 検索keyを指定します。</p></li>
<li><p><strong>added</strong> – NULL以外の値が指定された場合、新たにrecordが追加された時には1が、既存recordだった時には0がセットされます。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_get">
grn_id <code class="sig-name descname">grn_table_get</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, <em class="property">const</em> void *<em>key</em>, unsigned int <em>key_size</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_get" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>It finds a record that has key parameter and returns ID of the found record. If table parameter is a database, it finds an object (table, column and so on) that has key parameter  and returns ID of the found object.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – The table or database.</p></li>
<li><p><strong>key</strong> – The record or object key to be found.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_at">
grn_id <code class="sig-name descname">grn_table_at</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, grn_id <em>id</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_at" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>tableにidに対応するrecordが存在するか確認し、存在すれば指定されたIDを、存在しなければ <code class="docutils literal notranslate"><span class="pre">GRN_ID_NIL</span></code> を返します。</p>
<p>注意: 実行には相応のコストがかかるのであまり頻繁に呼ばないようにして下さい。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>id</strong> – 検索idを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_lcp_search">
grn_id <code class="sig-name descname">grn_table_lcp_search</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, <em class="property">const</em> void *<em>key</em>, unsigned int <em>key_size</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_lcp_search" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>tableが <code class="docutils literal notranslate"><span class="pre">GRN_TABLE_PAT_KEY</span></code> もしくは <code class="docutils literal notranslate"><span class="pre">GRN_TABLE_DAT_KEY</span></code> を指定して作ったtableなら、longest common prefix searchを行い、対応するIDを返します。</p>
<p>tableが <code class="docutils literal notranslate"><span class="pre">GRN_TABLE_HASH_KEY</span></code> を指定して作ったtableなら、完全に一致するキーを検索し、対応するIDを返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>key</strong> – 検索keyを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_get_key">
int <code class="sig-name descname">grn_table_get_key</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, grn_id <em>id</em>, void *<em>keybuf</em>, int <em>buf_size</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_get_key" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>tableのIDに対応するレコードのkeyを取得します。</p>
<p>対応するレコードが存在する場合はkey長を返します。見つからない場合は0を返します。対応するキーの検索に成功し、またbuf_sizeの長さがkey長以上であった場合は、keybufに該当するkeyをコピーします。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>id</strong> – 対象レコードのIDを指定します。</p></li>
<li><p><strong>keybuf</strong> – keyを格納するバッファ(呼出側で準備する)を指定します。</p></li>
<li><p><strong>buf_size</strong> – keybufのサイズ(byte長)を指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_delete">
grn_rc <code class="sig-name descname">grn_table_delete</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, <em class="property">const</em> void *<em>key</em>, unsigned int <em>key_size</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_delete" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>tableのkeyに対応するレコードを削除します。対応するレコードが存在しない場合は <code class="docutils literal notranslate"><span class="pre">GRN_INVALID_ARGUMENT</span></code> を返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>key</strong> – 検索keyを指定します。</p></li>
<li><p><strong>key_size</strong> – 検索keyのサイズを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_delete_by_id">
grn_rc <code class="sig-name descname">grn_table_delete_by_id</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, grn_id <em>id</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_delete_by_id" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>tableのidに対応するレコードを削除します。対応するレコードが存在しない場合は <code class="docutils literal notranslate"><span class="pre">GRN_INVALID_ARGUMENT</span></code> を返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>id</strong> – レコードIDを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_update_by_id">
grn_rc <code class="sig-name descname">grn_table_update_by_id</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, grn_id <em>id</em>, <em class="property">const</em> void *<em>dest_key</em>, unsigned int <em>dest_key_size</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_update_by_id" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>tableのidに対応するレコードのkeyを変更します。新しいkeyとそのbyte長をdest_keyとdest_key_sizeに指定します。</p>
<p>この操作は、<code class="docutils literal notranslate"><span class="pre">GRN_TABLE_DAT_KEY</span></code> 型のテーブルのみ使用できます。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>id</strong> – レコードIDを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_update">
grn_rc <code class="sig-name descname">grn_table_update</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, <em class="property">const</em> void *<em>src_key</em>, unsigned int <em>src_key_size</em>, <em class="property">const</em> void *<em>dest_key</em>, unsigned int <em>dest_key_size</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_update" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>tableのsrc_keyに対応するレコードのkeyを変更します。新しいkeyとそのbyte長をdest_keyとdest_key_sizeに指定します。</p>
<p>この操作は、<code class="docutils literal notranslate"><span class="pre">GRN_TABLE_DAT_KEY</span></code> 型のテーブルのみ使用できます。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>src_key</strong> – 対象レコードのkeyを指定します。</p></li>
<li><p><strong>src_key_size</strong> – 対象レコードのkeyの長さ(byte)を指定します。</p></li>
<li><p><strong>dest_key</strong> – 変更後のkeyを指定します。</p></li>
<li><p><strong>dest_key_size</strong> – 変更後のkeyの長さ(byte)を指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_truncate">
grn_rc <code class="sig-name descname">grn_table_truncate</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_truncate" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>tableの全レコードを一括して削除します。</p>
<p>注意: multithread環境では他のthreadのアクセスによって、存在しないアドレスへアクセスし、SIGSEGVが発生する可能性があります。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c type">
<dt id="c.grn_table_sort_key">
<em class="property">type </em><code class="sig-name descname">grn_table_sort_key</code><a class="headerlink" href="#c.grn_table_sort_key" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>TODO…</p>
</dd></dl>

<dl class="c type">
<dt id="c.grn_table_sort_flags">
<em class="property">type </em><code class="sig-name descname">grn_table_sort_flags</code><a class="headerlink" href="#c.grn_table_sort_flags" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>TODO…</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_sort">
int <code class="sig-name descname">grn_table_sort</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, int <em>offset</em>, int <em>limit</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>result</em>, <a class="reference internal" href="#c.grn_table_sort_key" title="grn_table_sort_key">grn_table_sort_key</a> *<em>keys</em>, int <em>n_keys</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_sort" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>table内のレコードをソートし、上位limit個の要素をresultに格納します。</p>
<p>keys.keyには、tableのcolumn,accessor,procのいずれかが指定できます。keys.flagsには、<code class="docutils literal notranslate"><span class="pre">GRN_TABLE_SORT_ASC</span></code> / <code class="docutils literal notranslate"><span class="pre">GRN_TABLE_SORT_DESC</span></code> のいずれかを指定できます。<code class="docutils literal notranslate"><span class="pre">GRN_TABLE_SORT_ASC</span></code> では昇順、<code class="docutils literal notranslate"><span class="pre">GRN_TABLE_SORT_DESC</span></code> では降順でソートされます。keys.offsetは、内部利用のためのメンバです。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>offset</strong> – sortされたレコードのうち、(0ベースで)offset番目から順にresにレコードを格納します。</p></li>
<li><p><strong>limit</strong> – resに格納するレコードの上限を指定します。</p></li>
<li><p><strong>result</strong> – 結果を格納するtableを指定します。</p></li>
<li><p><strong>keys</strong> – ソートキー配列へのポインタを指定します。</p></li>
<li><p><strong>n_keys</strong> – ソートキー配列のサイズを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c type">
<dt id="c.grn_table_group_result">
<em class="property">type </em><code class="sig-name descname">grn_table_group_result</code><a class="headerlink" href="#c.grn_table_group_result" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>TODO…</p>
</dd></dl>

<dl class="c type">
<dt id="c.grn_table_group_flags">
<em class="property">type </em><code class="sig-name descname">grn_table_group_flags</code><a class="headerlink" href="#c.grn_table_group_flags" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>TODO…</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_group">
grn_rc <code class="sig-name descname">grn_table_group</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, <a class="reference internal" href="#c.grn_table_sort_key" title="grn_table_sort_key">grn_table_sort_key</a> *<em>keys</em>, int <em>n_keys</em>, <a class="reference internal" href="#c.grn_table_group_result" title="grn_table_group_result">grn_table_group_result</a> *<em>results</em>, int <em>n_results</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_group" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>tableのレコードを特定の条件でグループ化します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>keys</strong> – group化キー構造体の配列へのポインタを指定します。</p></li>
<li><p><strong>n_keys</strong> – group化キー構造体の配列のサイズを指定します。</p></li>
<li><p><strong>results</strong> – group化の結果を格納する構造体の配列へのポインタを指定します。</p></li>
<li><p><strong>n_results</strong> – group化の結果を格納する構造体の配列のサイズを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_setoperation">
grn_rc <code class="sig-name descname">grn_table_setoperation</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table1</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table2</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>res</em>, grn_operator <em>op</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_setoperation" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>table1とtable2をopの指定に従って集合演算した結果をresに格納します。</p>
<p>resにtable1あるいはtable2そのものを指定した場合を除けば、table1, table2は破壊されません。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table1</strong> – 対象table1を指定します。</p></li>
<li><p><strong>table2</strong> – 対象table2を指定します。</p></li>
<li><p><strong>res</strong> – 結果を格納するtableを指定します。</p></li>
<li><p><strong>op</strong> – 実行する演算の種類を指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_difference">
grn_rc <code class="sig-name descname">grn_table_difference</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table1</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table2</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>res1</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>res2</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_difference" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>table1とtable2から重複するレコードを取り除いた結果をそれぞれres1, res2に格納します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table1</strong> – 対象table1を指定します。</p></li>
<li><p><strong>table2</strong> – 対象table2を指定します。</p></li>
<li><p><strong>res1</strong> – 結果を格納するtableを指定します。</p></li>
<li><p><strong>res2</strong> – 結果を格納するtableを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_columns">
int <code class="sig-name descname">grn_table_columns</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, <em class="property">const</em> char *<em>name</em>, unsigned int <em>name_size</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>res</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_columns" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>nameパラメータから始まるtableのカラムIDをresパラメータに格納します。name_sizeパラメータが0の場合はすべてのカラムIDを格納します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
<li><p><strong>name</strong> – 取得したいカラム名のprefixを指定します。</p></li>
<li><p><strong>name_size</strong> – nameパラメータの長さを指定します。</p></li>
<li><p><strong>res</strong> – 結果を格納する <code class="docutils literal notranslate"><span class="pre">GRN_TABLE_HASH_KEY</span></code> のtableを指定します。</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>格納したカラムIDの数を返します。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_size">
unsigned int <code class="sig-name descname">grn_table_size</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_size" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>tableに登録されているレコードの件数を返します。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>table</strong> – 対象tableを指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_table_rename">
grn_rc <code class="sig-name descname">grn_table_rename</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>table</em>, <em class="property">const</em> char *<em>name</em>, unsigned int <em>name_size</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_table_rename" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>ctxが使用するdbにおいてtableに対応する名前をnameに更新します。tableの全てのcolumnも同時に名前が変更されます。tableは永続オブジェクトでなければいけません。</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>name_size</strong> – nameパラメータのsize(byte)を指定します。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.25.22. <code class="docutils literal notranslate"><span class="pre">grn_table</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.25.22.1. Summary</a></li>
<li><a class="reference internal" href="#example">7.25.22.2. Example</a></li>
<li><a class="reference internal" href="#reference">7.25.22.3. Reference</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="grn_search.html"
                        title="previous chapter"><span class="section-number">7.25.21. </span><code class="docutils literal notranslate"><span class="pre">grn_search</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="grn_table_cursor.html"
                        title="next chapter"><span class="section-number">7.25.23. </span><code class="docutils literal notranslate"><span class="pre">grn_table_cursor</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="grn_table_cursor.html" title="7.25.23. grn_table_cursor"
             >next</a> |</li>
        <li class="right" >
          <a href="grn_search.html" title="7.25.21. grn_search"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" ><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.22. </span><code class="docutils literal notranslate"><span class="pre">grn_table</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>